Groups | Search | Server Info | Keyboard shortcuts | Login | Register [http] [https] [nntp] [nntps]
Groups > linux.kernel > #1327028 > unrolled thread
| Started by | Ard Biesheuvel <ard.biesheuvel@linaro.org> |
|---|---|
| First post | 2016-02-04 18:20 +0100 |
| Last post | 2016-02-05 11:00 +0100 |
| Articles | 2 — 2 participants |
Back to article view | Back to linux.kernel
[PATCH] scripts/link-vmlinux.sh: force error on kallsyms failure Ard Biesheuvel <ard.biesheuvel@linaro.org> - 2016-02-04 18:20 +0100
Re: [PATCH] scripts/link-vmlinux.sh: force error on kallsyms failure Michal Marek <mmarek@suse.cz> - 2016-02-05 11:00 +0100
| From | Ard Biesheuvel <ard.biesheuvel@linaro.org> |
|---|---|
| Date | 2016-02-04 18:20 +0100 |
| Subject | [PATCH] scripts/link-vmlinux.sh: force error on kallsyms failure |
| Message-ID | <qYvJw-4Y7-1@gated-at.bofh.it> |
Since the output of the invocation of scripts/kallsyms is piped directly
into the assembler, error messages it emits are visible on stderr, but
a non-zero return code is ignored, and the build simply proceeds in that
case. However, the resulting kernel is most likely broken, and will crash
at boot. So capture the return code of scripts/kallsyms explicitly (in a
POSIX shell compatible manner), and abort the script if it is non-zero.
Signed-off-by: Ard Biesheuvel <ard.biesheuvel@linaro.org>
---
scripts/link-vmlinux.sh | 9 ++++++---
1 file changed, 6 insertions(+), 3 deletions(-)
diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index b83f918c7830..71882648e064 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh
@@ -93,9 +93,12 @@ kallsyms()
local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
- ${NM} -n ${1} | \
- scripts/kallsyms ${kallsymopt} | \
- ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
+ # capture the return code of scripts/kallsyms in $RC
+ local RC=`(${NM} -n ${1} | \
+ (scripts/kallsyms ${kallsymopt}; echo $? 1>&3) | \
+ ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -) 3>&1`
+
+ [ $RC -eq 0 ]
}
# Create map file with all symbols from ${1}
--
2.5.0
[toc] | [next] | [standalone]
| From | Michal Marek <mmarek@suse.cz> |
|---|---|
| Date | 2016-02-05 11:00 +0100 |
| Message-ID | <qYLlg-6Xi-19@gated-at.bofh.it> |
| In reply to | #1327028 |
On 2016-02-04 18:09, Ard Biesheuvel wrote:
> - ${NM} -n ${1} | \
> - scripts/kallsyms ${kallsymopt} | \
> - ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
> + # capture the return code of scripts/kallsyms in $RC
> + local RC=`(${NM} -n ${1} | \
> + (scripts/kallsyms ${kallsymopt}; echo $? 1>&3) | \
> + ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -) 3>&1`
> +
> + [ $RC -eq 0 ]
This now ignores errors by the assembler (and makes the function hard to
read). Please change it to use a temporary file.
Michal
[toc] | [prev] | [standalone]
Back to top | Article view | linux.kernel
csiph-web